#include <conio.h>
#include <alloc.h>
#include <process.h>
#include <strstream.h>
#include <realcnvt.h>
#include "bsreal.h"


//***************************[ REALCNVT CLASS ]****************************
//***************************[ REALCNVT CLASS ]****************************
//***************************[ REALCNVT CLASS ]****************************



BSreal::BSreal(bassngl data){           // CONSTRUCTOR for bassngl
        bsreal holdtank;                // We have to work from a holding area
        memmove(holdtank,data,4);       // because bassngltodouble modifies the
        memmove(bsreal_val,data,4);     // source.  We don't want it changed.
        double_val=bassngltodouble(holdtank);
        long_val=(unsigned long)double_val;
        #ifdef DEBUG_BSreal
                dump("BSreal(bassngl data)  // constructor ");
        #endif
}


BSreal::BSreal(double Value){           // CONSTRUCTOR for char,int,long,double
        doubletobassngl(&bsreal_val,Value);
        long_val=(unsigned long)Value;
        double_val=Value;
        #ifdef DEBUG_BSreal
                dump("BSREAL(unsigned char Value)");
        #endif
}

void BSreal::operator ++ (){            // Increment BSreal     by 1
        double_val++;
        BSreal tmp(double_val);
        tmp.copy_BSreal_to(bsreal_val);
        long_val=(unsigned long)double_val;}

void BSreal::operator -- (){            // Decrement BSreal by 1
        double_val--;
        BSreal tmp(double_val);
        tmp.copy_BSreal_to(bsreal_val);
        long_val=(unsigned long)double_val;}

void BSreal::copy_BSreal_to(bassngl dest){  // Copy BSreal to location dest
        memmove(dest,bsreal_val,4);}


unsigned long BSreal::get_long_value(){ // Return the long value
        return long_val;}



//==[ if DEBUG_BSreal is defined the class data will be dumped to screen ]==
//==[ for debugging purposes                                                     ]==
//
void BSreal::dump(char *str){
        int i;
		LINE;
        cprintf(CR"Dump of class 'BSreal' function ==> %s",str);
        cout << CR"long_val=   " << long_val;
        cout << CR"double_val= " << double_val << CR << "bsreal_val= hex(char) ";
        for (i=0;i<4;i++) cprintf("%02X(%c), ",bsreal_val[i],bsreal_val[i]);
        cout << CR;
        LINE;
        getch();}



