#include <string.h>
#include <stdlib.h>
#include <io.h>
#include <iostream.h>
#include <alloc.h>
#include "msgcls.h"
#include "bsreal.h"
#include <mem.h>

extern exit_err(int);

// RETURN TEXT STRING IN PCBOARD OR IBM TEXT FORMAT (DEFAULT IS IBM)
//
char* IMBH::get_msg_text(int mode){
        char *ptr,*tmp,*tmpptr;
        tmp=NULL;
        if (text==NULL) return "";      // In case we're returning to cout
        if(mode==PCB_TEXT) return text;
        text_flag=IBM_TEXT;
        int bytes=strlen(text);
        if((tmp=(char*)malloc(bytes+1))==NULL){ // let's drag a null with us
                cout << "\nError encountered trying to allocate memory for\nconverted text!!!\a";
                exit(1);}
        memmove(tmp,text,bytes+1);
        ptr=text;
        tmpptr=tmp;             // We can't free tmp if we move it so we use a pointer
        while (*tmpptr!=NULL){
                *ptr=*tmpptr;
                if(*tmpptr==''){
                        *ptr='\15';
                        ptr++;
                        *ptr='\12';}
                ptr++;
                tmpptr++;}
        if(tmp!=NULL)
                free(tmp);
        return(text);
}


char* IMBH::IBM_to_PCB(char *str){
        char *ptr,*tmp,*tmpptr;
        tmp=NULL;
        if ((str==NULL)||(*str=='\0')) return "";       // In case we're returning to cout
        int bytes=strlen(text);
        if((tmp=(char*)malloc(bytes+1))==NULL){ // let's drag a null with us
                cout << "\nError encountered trying to allocate memory for\nconverted text!!!\a";
                exit(1);}
        memset(tmp,'\0',bytes+1);
        memmove(tmp,text,bytes+1);
        ptr=str;
        tmpptr=tmp;             // We can't free tmp if we move it so we use a pointer
        while (*tmpptr!=NULL){
                *ptr=*tmpptr;
                if(*tmpptr=='\r'){
                        *ptr='\';
                        tmpptr++;}
                ptr++;
                tmpptr++;}
        *ptr='\0';
        bytes=strlen(text);
        memmove(tmp,text,bytes); // Hold onto it while we setup text with ' '
        memset(text,' ',((int)IMBHdata.num_blks-1)*128);
        memmove(text,tmp,bytes-1);  // -1 so we don't copy NULL
        if(tmp!=NULL)
                free(tmp);
        return(text);
}


// CONSTRUCTOR FOR INDIVIDUAL MESSAGE CLASS (reads in message header and text)
//

IMBH::IMBH(int handle,ulong offset){
        text=NULL;
        text_flag=PCB_TEXT;     // Default set to PCB mode (no 0d 0a in text)

        if (offset!=0){
                if((lseek(handle,offset,SEEK_SET))==-1) exit_err(SEEK_ERROR);
                if((read(handle,&IMBHdata,sizeof(IMsgBaseHdr)))!=sizeof(IMsgBaseHdr)) exit_err(READ_ERROR);
                int blocks=((int)IMBHdata.num_blks*128);
                if(blocks==0) return;   // Just in case....
                        // Notice that we are allocating 128 bytes more then required.
                        // This is so we can convert the message base to TEXT
                        // (i.e.,  to 0d 0a)
                if((text=(char*) malloc(blocks))==NULL) exit_err(MEM_ERROR);
                memset(text,'\0',blocks);       // We are going to count on these NULLs to
                                                                        // Help us find the end of the text message.
                if((read(handle,text,blocks-128))!=blocks-128)  // We have 128 more bytes
                                exit_err(READ_ERROR);                                   // then we need.
        }
}

IMBH::~IMBH(void){
        if(text!=NULL);
                free(text);
}
