#include <stdlib.h>
#include <conio.h>
#include <string.h>
#include <alloc.h>
#include <process.h>
#include <fcntl.h>
#include <iostream.h>
#include <io.h>
#include "msgcls.h"
#include "bsreal.h"

msg_index::msg_index(char *fn):MBH(fn){
        char *msg_filename;
        msg_filename=get_filename();
                strcpy(filename,msg_filename);  // copy msg filename
                strcat(filename,".NDX");

        // Let's open the file read/write assuming that if someone is going to
        // update this file it will only be after they locked the msg base
        if((idx_handle=open(filename,O_BINARY|O_RDWR|O_DENYNONE))==-1){
                cout << CR"Error encountered trying to open "<< filename;
                exit(1);  // exit if we can't open the index
        }
        lowmsg=get_low_msg();
}
msg_index::~msg_index(){
        close(idx_handle);
}

ulong msg_index::get_msgidx_offset(ulong msgnmbr){
        lseek(idx_handle,(msgnmbr-lowmsg)*4,SEEK_SET);
        read(idx_handle,b_offset,sizeof(bsreal));
        BSreal mo(b_offset);
        long movalue=mo.get_long_value();
        if(movalue<0) return DELETED;
        if(movalue==0) return NOMSG;
        return (ulong)(movalue-1)*128;
}

ulong msg_index::set_msgidx_offset(ulong msgnmbr,ulong offset){
                bsreal b_offset;
                ulong l_offset;
                if(get_MBH_flg()==YES){
                        l_offset=(offset/128)+1;// convert to block number
                        BSreal mo(l_offset);    // convert to bsreal
                        mo.copy_BSreal_to(b_offset);    // Copy bsreal to our variable
                        lseek(idx_handle,(msgnmbr-lowmsg)*4,SEEK_SET);  // set index offset
                        write(idx_handle,b_offset,sizeof(bsreal));      // Write value
                        return mo.get_long_value();
                } else {
                        cout << CR CR"\b\bMessage base header was not updated!";
                        cout << CR "You must first update it by using save_bmh().";
                        cout << CR "See MSGIDX.DOC for more details...";
                        exit(1); // Rather exit then risk corrupting index.
                }
}


